
{Discussion: When you first call the graphics procedures set FirstTime to
 TRUE. Certain values must be initialized.  In subsequent calls set
 FirstTime to FALSE}

UNIT AKGraph;

INTERFACE

USES GlobType,LinLib,TreeGra,Graph,Math,Utility,Crt,VGAPal,Laserpr,
     FileIn,PrintSc2;

PROCEDURE DrawGraph(VAR M : AkMatrix;Name : String);


IMPLEMENTATION

TYPE
    IntegerVect   = Array[1..MaxClasses] OF Integer;
    IntegerArr    = Array[1..MaxIntervals] OF IntegerVect;
    IntArrPtr     = ^IntegerArr;
    Coordinate = Array[1..2] OF Integer;
    RealCoord  = Array[1..2] OF Single;
    BarArr     = Array[1..9] OF Coordinate;
VAR
   MaxHt,
   BaseY,GlobScaleX,
   GlobScaleY           : Integer;
   SinAng,CosAng        : Single;
   AxesArr,WallArr      : Array[1..7] OF Coordinate;
   AxesZ                : Array[1..6] OF Integer;
   B                    : BarArr;
   Z                    : Array[1..9] OF Integer;
   Ch                   : Char;


{get the Sin, Cos once and store them in a global variable}

PROCEDURE Displacement(Angle : Single);
          BEGIN
               Angle  := DegToRad * Angle;    {from math}
               SinAng := Sin(Angle) * AspRatio;
               CosAng := Cos(Angle);
END;

{Perform a simple integer 3D rotation}

PROCEDURE Rotate(VAR Coord : Coordinate;Z : Integer);
          BEGIN
               Coord[1] := Round(Coord[1] +
                                 CosAng * Z -
                                 CosAng * Coord[1]);
               Coord[2] := Round(Coord[2] -
                                 SinAng * Z +
                                 SinAng * Coord[1]);
END;

{Perform a simple real 3D rotation and return an integer coordinate -
 used to create mesh}

PROCEDURE RealRotate(VAR Coord  : Coordinate;
                     VAR RCoord : RealCoord;
                         Z      : Single);
          BEGIN
               RCoord[1] :=  RCoord[1] + (CosAng * Z) -
                            (CosAng * RCoord[1]);
               Coord[2] :=  Round(RCoord[2] -
                                 (SinAng * Z) +
                                 (SinAng * RCoord[1]));
              Coord[1] := Round(RCoord[1]);
END;

{Create the polygons that are used to create the axes and the back wall}

PROCEDURE GetAxesArr;
          CONST
              X = 1; Y = 2; Z = 3;
         VAR
            Ct            : Byte;
            ScaleX,ScaleY : Integer;
          BEGIN
              ScaleX := GlobScaleX;
              ScaleY := BaseY;
              AxesArr[1,X] := 10;
              AxesArr[1,Y] := ScaleY;
              AxesZ[1] := 0;
              AxesArr[2,X] := ScaleX;
              AxesArr[2,Y] := ScaleY;
              AxesZ[2] := 0;
              AxesArr[3,X] := ScaleX;
              AxesArr[3,Y] := ScaleY;
              AxesZ[3] := MaxY;
              AxesArr[4,X] := 10;
              AxesArr[4,Y] := ScaleY;
              AxesZ[4] := MaxY;
              AxesArr[5,X] := ScaleX;
              AxesArr[5,Y] := AxesArr[3,2] - MaxHt;
              AxesZ[5] := MaxY;
              WallArr := AxesArr;
              FOR Ct := 1 TO 5 DO
                  Rotate(AxesArr[Ct],AxesZ[Ct]);
              WallArr[2]   := WallArr[4];
              WallArr[5,1] := WallArr[4,1];
              WallArr[5,2] := WallArr[4,2] - MaxHt;
              WallArr[4,1] := WallArr[3,1];
              WallArr[4,2] := WallArr[3,2] - MaxHt;
              WallArr[6,1] := WallArr[1,1];
              WallArr[6,2] := WallArr[1,2] - MaxHt;
              AxesZ[2] := AxesZ[4];
              AxesZ[5] := AxesZ[4];
              AxesZ[4] := AxesZ[3];
              AxesZ[6] := 0;
              FOR Ct := 1 TO 6 DO
                  Rotate(WallArr[Ct],AxesZ[Ct]);
END;

{Draw the axea and the back wall on the screen}

{Draw the mesh}

PROCEDURE DrawMesh(     Row,Col     : Byte;
                    VAR SpeciesDist : IntegerArr;
                        Color       : Byte);
          VAR
             Ct                                : Word;
             XPlus1,ZPlus1,
             XStart,ZStart,
             BarScaleX,BarScaleZ,Avg           : Single;
             Ct1,Ct2                           : Byte;
             RCoord                            : RealCoord;
             Square                            : Array[1..4] OF Coordinate;
          BEGIN
               BarScaleX := (GlobScaleX-10)/Pred(Col);
               BarScaleZ := (MaxY-2)/Pred(Row);
               SetColor(LightCyan);
               SetLineStyle(0,0,0);
               ZStart := MaxY;
               FOR Ct1 := 1 TO Pred(Row) DO BEGIN
                   ZPlus1 := ZStart - BarScaleZ;
                   XStart := 10;
                   FOR Ct2 := 1 TO Pred(Col) DO BEGIN
                       XPlus1 := XStart + BarScaleX;
                       RCoord[1] := XStart;
                       RCoord[2] := BaseY - SpeciesDist[Ct1,Ct2];
                       RealRotate(Square[1],RCoord,ZStart);
                       RCoord[1] := XPlus1;
                       RCoord[2] := BaseY - SpeciesDist[Ct1,Succ(Ct2)];
                       RealRotate(Square[2],RCoord,ZStart);
                       RCoord[1] := XPlus1;
                       RCoord[2] := BaseY - SpeciesDist[Succ(Ct1),Succ(Ct2)];
                       RealRotate(Square[3],RCoord,ZPlus1);
                       RCoord[1] := XStart;
                       RCoord[2] := BaseY - SpeciesDist[Succ(Ct1),Ct2];
                       RealRotate(Square[4],RCoord,ZPlus1);
                       IF Gd = 7 THEN
                          SetFillStyle(1,0)
                       ELSE BEGIN
                            IF Color > 15 THEN BEGIN
                               Avg := (SpeciesDist[Ct1,Ct2] +
                                       SpeciesDist[Ct1,Ct2+1] +
                                       SpeciesDist[Ct1+1,Ct2+1] +
                                       SpeciesDist[Ct1+1,Ct2])*0.25;
                               Avg := Avg/MaxY;
                               if (Avg > 0) and (Avg < 0.025) then
                                  SetFillStyle(9,1)
                               else
                                   SetFillStyle(1,Round(Avg * 40));
                             END
                             ELSE
                                 SetFillStyle(1,Color);
                       END;
                       FillPoly(4,Square);
                       XStart := XPlus1;
                   END;
                       ZStart := ZPlus1;
               END;
END;

{Scale the matrix to the screen and return as an integer matrix}

PROCEDURE ScaleMatrix(    Row,Col  : Byte;
                      VAR M        : Matrix2;
                      VAR Maximum  : Single;
                      VAR GraphArr : IntegerArr);
          VAR
             Ct             : Byte;
             Holder         : Single;
          BEGIN
               Maximum := 0;
               FOR Ct := 1 TO Row DO BEGIN
                   Holder := Max(Col,M[Ct]);           {whole matrix}
                   IF Holder > Maximum THEN
                      Maximum := Holder;
               END;
               IF Maximum < 0.000001 THEN
                  Maximum := 0.000001;
               Holder := MaxHt/Maximum;           {scale to screen}
               FOR Ct := 1 TO Row DO               {scale the whole matrix}
                   RoundAndScaleRow(Col,Holder,M[Ct],GraphArr[Ct]);
END;

{makes a 3d bar chart of a positive matrix - entries must be positive}

PROCEDURE Graph3DMesh (    Row,Col         : Byte;
                       VAR M               : Matrix2;
                           Color,Palette   : Byte;
                           FirstTime       : Boolean);
          VAR
             GraphArr       : IntArrPtr;
             Maximum        : Single;
          BEGIN
               New(GraphArr);
               ChangePalette(Palette);
               ScaleMatrix(Row,Col,M,Maximum,GraphArr^);
               IF FirstTime THEN BEGIN
                  Displacement(45);
               END;
               DrawMesh(Row,Col,GraphArr^,Color);
               Dispose(GraphArr);
END;
{initializes graphics and global constants}

PROCEDURE Init3DGraphics;
          BEGIN
               InitializeGraphics;
               MaxHt := MaxY SHR 2;
               CASE Gd OF
                   9 : BEGIN
                              BaseY := MaxY - 250;
                              GlobScaleX := MaxX + MaxX SHR 1;
                          END;
                    7 : BEGIN
                              BaseY := MaxY - 200;
                              GlobScaleX := MaxX + MaxX SHR 1;
                          END;
                    3   : BEGIN
                               BaseY := MaxY - 200;
                               GlobScaleX := MaxX + 50;
                          END;
               END;
END;
PROCEDURE TransferToGraph(VAR M : AkMatrix;VAR G : Matrix2);
          VAR
             Ct1,Ct2 : Word;
             i,j     : Word;
          BEGIN
               i := 0;
               FOR Ct1 := 51 DOWNTO 1 DO BEGIN
                   j := 0;
                   FOR Ct2 := 51 DOWNTO 1 DO BEGIN
                       G[Ct1,Ct2] := M[i,j];
                       Inc(j,2);
                   END;
                   Inc(i,2);
               END;
END;
PROCEDURE WriteTitle2(VAR Name : String);
          BEGIN
               OutTextXY(GetMaxX-100,10,Name);
               SetTextJustify(1,1);
               OutTextXY(GetMaxX DIV 2, GetMaxY - 8,
                          'Any key to continue, ESC to quit');
               SetTextJustify(0,2);
END;
PROCEDURE GetKeys(VAR Ch,Ch2 : Char;VAR Ct : Byte;VAR Grid : Matrix2);
          VAR
             Err : Boolean;
          LABEL
               Loop;
          BEGIN
      LOOP:
           Ch2 := #0;
           Ch := UpCase(ReadKey);
           IF Ch = #0 THEN
              Ch2 := ReadKey;
            WITH GlobIO DO BEGIN
              IF (Ch2 IN [#25,#17]) AND (Printer <> 0) THEN BEGIN
                 Graph3dMesh(51,51,Grid,0,2,FALSE);
                 IF Ch2 = #25 THEN BEGIN
                    IF Printer = 1 THEN
                       PrintScreen(FALSE,Gd,Err)
                    ELSE
                        LaserPrintScreen(Gd,Err);
                 END
                 ELSE IF Ch2 = #17 THEN BEGIN
                      IF Printer = 1 THEN
                         PrintScreen(TRUE,Gd,Err)
                      ELSE
                           LaserLandscapePrintScreen(Gd,Err);
                 END;
                 Graph3dMesh(51,51,Grid,20,Ct,FALSE);
                 GOTO Loop;
              END
              ELSE BEGIN
                   IF Ch <> #27 THEN BEGIN
                      Inc(Ct);
                      IF Ct > 5 THEN Ct := 2;
                      ChangePalette(Ct);
                  END;
              END;
            END;
END;
PROCEDURE DrawGraph(VAR M : AkMatrix;Name : String);
          VAR
             Ct         : Byte;
             GraphGrid  : MatPtr2;
             Ch,Ch2     : Char;
          BEGIN
               New(GraphGrid);
               TransferToGraph(M,GraphGrid^);
               Init3DGraphics;
               WriteTitle2(Name);
               Graph3dMesh(51,51,GraphGrid^,20,2,TRUE);
               Ct := 2;
               REPEAT
                     GetKeys(Ch,Ch2,Ct,GraphGrid^);
               UNTIL Ch = #27;
               CloseGraphics;
               Dispose(GraphGrid);
END;
BEGIN
END.

