UNIT AKPLOT;

INTERFACE

USES GlobType,Linlib,TreeGra,Graph,ContLib,MCP;

PROCEDURE MakeContours(    PointNo                     : Word;
                       VAR G                           : AKMatrix;
                       VAR X,Y                         : AKArr;
                           St                          : String;
                           ContVal                     : Single;
                           MultSw                      : Boolean);
PROCEDURE DoMCP(      PointNo                     : Word;
                  VAR X,Y                         : Arr;
                      St                          : String);
IMPLEMENTATION
     CONST
          Color95    : Byte = White;
          Color90    : Byte = LightCyan;
          Color75    : Byte = LightGreen;
          PointColor : Byte = Yellow;

VAR
   MinGraphX,MinGraphY,DiffGraph : Single;
PROCEDURE ScaleSystem(    n                  : Word;
                      VAR X,Y                : AKArr;
                      VAR MinX,MinY,
                          Diff               : Single);
          VAR
             MaxX,MaxY,DiffY : Single;
          BEGIN
               MaxX := Max(n,X);
               MaxY := Max(n,Y);
               MinX := Min(n,X);
               MinY := Min(n,Y);
               Diff := MaxX - MinX;
               DiffY := MaxY - MinY;
               IF DiffY > Diff THEN
                  Diff := DiffY;
END;
PROCEDURE t(x,y : Word);
          BEGIN
               Line(x,y-2,x,y+2);
               Line(x+2,y,x-2,y);
END;
PROCEDURE PlotPts(    n                       : Word;
                  VAR X,Y                     : AKArr;
                      MinX,MinY,Diff          : Single;
                      Color                   : Byte);

          VAR
             Ct,PtX,PtY,ScreenDim : Word;
             Scale                : Single;
          BEGIN
               ScreenDim := GetMaxY SHR 2;
               Scale := (0.6 * GetMaxY)/Diff;
               SetColor(Color);
               FOR Ct := 1 TO N DO BEGIN
                   PtX := Round((X[Ct] - MinX) * Scale) + ScreenDim;
                   PtY := GetMaxY-Round((Y[Ct] - MinY) * Scale) - ScreenDim;
                   T(PtX,PtY);
               END;
END;
PROCEDURE PlotContour(    Polyn                   : Word;
                      VAR X,Y                     : AKArr;
                      VAR Ns,Ne                   : PolyArr;
                      VAR Ptype                   : ShortPolyArr;
                          MinX,MinY,Diff          : Single;
                          Color                   : Byte);
          VAR
             Ct,PtX,PtY,ScreenDim : Word;
             Scale                : Single;
             i,j,J0,J1,Hx,Hy      : Word;
          BEGIN
               Screendim := GetMaxY SHR 2;
               Scale := (0.6 * GetMaxY)/Diff;
               SetColor(8 + Color);
               SetLineStyle(0,0,3);
               FOR i:=1 TO Polyn DO BEGIN
                   J0 := Ns[i];
                   J1 := Ne[i];
                   PtX := Round((X[J0] - MinX) * Scale) + ScreenDim;
                   PtY := GetMaxY-Round((Y[J0] - MinY) * Scale) - ScreenDim;
                   Hx := Ptx;
                   Hy := Pty;
                   MoveTo(PtX,PtY);
                   FOR j:=Succ(J0) TO J1 DO BEGIN
                       PtX := Round((X[j] - MinX) * Scale) + ScreenDim;
                       PtY := GetMaxY-Round((Y[j] - MinY) * Scale) - ScreenDim;
                       LineTo(PtX,PtY);
                    END;
                    LineTo(Hx,Hy);
               END;
               SetLineStyle(0,0,0);
END;
PROCEDURE PlotMCP(    n                           : Word;
                      VAR X,Y                     : AkArr;
                          MinX,MinY,Diff          : Single;
                          Color                   : Byte);
          VAR
             Ct,PtX,PtY,ScreenDim : Word;
             Scale                : Single;
             i,j,J0,J1            : Word;
          BEGIN
               Screendim := GetMaxY SHR 2;
               Scale := (0.6 * GetMaxY)/Diff;
               SetColor(8 + Color);
               SetLineStyle(0,0,3);
               PtX := Round((X[1] - MinX) * Scale) + ScreenDim;
               PtY := GetMaxY-Round((Y[1] - MinY) * Scale) - ScreenDim;
               MoveTo(PtX,PtY);
               FOR j:= 2 TO n DO BEGIN
                   PtX := Round((X[j] - MinX) * Scale) + ScreenDim;
                   PtY := GetMaxY-Round((Y[j] - MinY) * Scale) - ScreenDim;
                   LineTo(PtX,PtY);
               END;
               SetLineStyle(0,0,0);
END;

PROCEDURE SetColors;
          VAR
             Gd,Gm : Integer;
          BEGIN
               DetectGraph(Gd,Gm);
               IF Gd = 7 THEN BEGIN
                  Color95    := White;
                  Color90    := White;
                  Color75    := White;
                  PointColor := White;
               END;
END;
PROCEDURE OpenGraphics;
          BEGIN
               InitializeGraphics;
               SetColors;
END;
PROCEDURE DoPoints(n : Word; VAR x,y : AkArr);
          BEGIN
               ScaleSystem(n,X,Y,MinGraphX,MinGraphY,DiffGraph);
               OpenGraphics;
               PlotPts(n,X,Y,MinGraphX,MinGraphY,DiffGraph,14);
END;
PROCEDURE DoContours(    Ct               : Word;
                     VAR Poly             : PolyType);
          BEGIN
               WITH Poly DO
                    PlotContour(NPoly,Px,Py,Ns,Ne,PType,MinGraphX,
                                MinGraphY,DiffGraph,Ct);
END;
PROCEDURE InitStuff(VAR St : String);
          VAR
             StartX : Word;
          BEGIN
               SetColor(LightCyan);
               StartX := GetMaxX - 130;
               OutTextXY(StartX,10,St);
               SetColor(White);
               OutTextXY(StartX-60,20,'CONTOUR (%)  AREA (ha)');
               SetTextJustify(1,1);
               OutTextXY(GetMaxX SHR 1, GetMaxY-10,'Any key to continue');
               SetTextJustify(0,2);
END;
PROCEDURE InitMCP(VAR St : String);
          VAR
             StartX : Word;
          BEGIN
               SetColor(LightCyan);
               StartX := GetMaxX - 130;
               OutTextXY(StartX,10,St);
               SetColor(White);
               OutTextXY(StartX-60,20,'   MCP 100% AREA (ha)');
               SetTextJustify(1,1);
               OutTextXY(GetMaxX SHR 1, GetMaxY-10,'Any key to continue');
               SetTextJustify(0,2);
END;
PROCEDURE Legend(Ct : Word;Contour,Area : Single);
          VAR
             St,St2         : String[20];
             IntCont,Xs,Ys  : Word;
          BEGIN
               Area := Area/InputScale;
               Xs := GetMaxX - 170;
               IntCont := Round(Contour*100);
               Str(Area:10:2,St);
               Str(IntCont:3,St2);
               SetLineStyle(0,0,3);
               SetColor(8+Ct);
               Ys := 34+(Ct*10);
               Line(Xs,Ys,Xs+10,Ys);
               SetLineStyle(0,0,0);
               SetColor(15);
               OutTextXY(Xs+30,Ys-4,St2 + ' ' + St);
END;
PROCEDURE MCPLegend(Area : Single);
          VAR
             St             : String[20];
             Xs             : Word;
          BEGIN
               Area := Area/InputScale;
               Xs := GetMaxX - 129;
               Str(Area:10:2,St);
               SetColor(15);
               OutTextXY(Xs,40,St);
END;
PROCEDURE MakeContours(    PointNo                     : Word;
                       VAR G                           : AKMatrix;
                       VAR X,Y                         : AKArr;
                           St                          : String;
                           ContVal                     : Single;
                           MultSw                      : Boolean);
          VAR
             Ct,Ct2   : Word;
             Poly     : PolyPtr;
          BEGIN
               New(Poly);
               Multiple := MultSw;
               InitContour(PointNo,X,Y,G);
               DoPoints(PointNo,X,Y);
               InitStuff(St);
               IF Multiple THEN BEGIN
                  FOR Ct := 1 TO ContNo DO BEGIN
                      MakeAContour(PointNo,ContVect[Ct],Poly^,G);
                      DoContours(Ct,Poly^);
                      Legend(Ct,ContVect[Ct],Poly^.Area);
                  END;
               END ELSE BEGIN
                   MakeAContour(PointNo,ContVal,Poly^,G);
                   DoContours(1,Poly^);
                   Legend(1,ContVal,Poly^.Area);
               END;
               DisposeContour;
               Dispose(Poly);
END;
PROCEDURE DoMCP(      PointNo                     : Word;
                  VAR X,Y                         : Arr;
                      St                          : String);
          VAR
             Xx,Yy : AkArrPtr;
             NewN  : Word;
             Area  : Single;
          BEGIN
               New(Xx);
               New(Yy);
               MoveRow(x,Xx^,PointNo);
               MoveRow(y,Yy^,PointNo);
               DoPoints(PointNo,XX^,YY^);
               InitMCP(St);
               MakeMCP(PointNo,XX^,YY^,NewN,Area);
               PlotMCP(NewN,XX^,YY^,MinGraphX,MinGraphY,DiffGraph,3);
               MCPLegend(Area);
               Dispose(Xx);
               Dispose(Yy);
END;
BEGIN
END.



