Uses Math,TreeGra,Graph,Drivers;
Type
    Coordinate = Array[1..2] of Integer;
    RealCoord  = Array[1..2] of Single;
VAR
   SinAng,CosAng : Single;
{get the Sin, Cos once and store them in a global variable}

PROCEDURE Displacement(Angle : Single);
          BEGIN
               Angle  := DegToRad * Angle;    {from math}
               SinAng := Sin(Angle) * AspRatio;
               CosAng := Cos(Angle);
END;

{Perform a simple integer 3D rotation}

PROCEDURE Rotate(VAR Coord : Coordinate;Z : Integer);
          BEGIN
               Coord[1] := Round(Coord[1] +
                                 CosAng * Z -
                                 CosAng * Coord[1]);
               Coord[2] := Round(Coord[2] -
                                 SinAng * Z +
                                 SinAng * Coord[1]);
END;

{Perform a simple real 3D rotation and return an integer coordinate -
 used to create mesh}

PROCEDURE RealRotate(VAR Coord  : Coordinate;
                     VAR RCoord : RealCoord;
                         Z      : Single);
          BEGIN
               RCoord[1] :=  RCoord[1] + (CosAng * Z) -
                            (CosAng * RCoord[1]);
               Coord[2] :=  Round(RCoord[2] -
                                 (SinAng * Z) +
                                 (SinAng * RCoord[1]));
              Coord[1] := Round(RCoord[1]);
END;
Procedure Compass(Xloc,YLoc : integer);
          Const
               N = 1; S = 2; E = 3; W = 4;
          VAR
             Direction : Array[1..4] of Coordinate;
             Ct        : word;
          begin
               Direction[N][1] := XLoc;
               Direction[N][2] := Yloc - 30;
               Direction[S][1] := XLoc;
               Direction[S][2] := Yloc + 30;
               Direction[E][1] := XLoc + 30;
               Direction[E][2] := Yloc;
               Direction[W][1] := XLoc - 30;
               Direction[W][2] := Yloc;
               For ct := 1 to 4 do
                   Rotate(Direction[Ct],0);
               Line(Direction[1,1],Direction[1,2],
                    Direction[2,1],Direction[2,2]);
               Line(Direction[3,1],Direction[3,2],
                    Direction[4,1],Direction[4,2]);
end;
VAR
   gd,gm : Integer;
begin
     Gd := 0;
     Gm := 0;
     Displacement(45);
     InitGraph(gd,gm,'');
     Compass(500,200);
     ReadLn;
     CloseGraph;
end.