
{Discussion: When you first call the graphics procedures set FirstTime to
 TRUE. Cetrain values must be initialized.  In subsequent calls set
 FirstTime to FALSE}

UNIT Graph3D;

INTERFACE

USES LinLib,TreeGra,Graph,Math,Utility,Crt;
CONST
     MaxClasses = 51;
     MaxIntervals = 51;
TYPE
    Vector   = Array[1..MaxClasses] OF Single;
    Matrix   = Array[1..MaxIntervals] OF Vector;
    StringVect = Array[1..MaxClasses] OF String[5];

PROCEDURE Init3DGraphics;
PROCEDURE Graph3DBars(    Row,Col         : Byte;
                      VAR M               : Matrix;
                      VAR Species         : StringVect;
                          DiamStart,
                          DiamInc         : Single;
                          Title,Message   : String;
                          FirstTime       : Boolean);
PROCEDURE Graph3DBarsG(    Row,Col         : Byte;
                       VAR M               : Matrix;
                           XStart,
                           XInc,
                           YStart,
                           YInc            : Single;
                           Title,XTitle,
                           YTitle,Message  : String;
                           Color           : Byte;
                           FirstTime       : Boolean);
PROCEDURE Graph3DAreas(    Row,Col         : Byte;
                       VAR M               : Matrix;
                       VAR Species         : StringVect;
                           DiamStart,
                           DiamInc         : Single;
                           Title,Message   : String;
                           FirstTime       : Boolean);
PROCEDURE Graph3DMesh (    Row,Col         : Byte;
                       VAR M               : Matrix;
                           XStart,
                           XInc,
                           YStart,
                           YInc            : Single;
                           Title1,Title2,
                           XTitle,
                           YTitle,Message  : String;
                           Color           : Byte;
                           FirstTime       : Boolean);


IMPLEMENTATION

TYPE
    IntegerVect   = Array[1..MaxClasses] OF Integer;
    IntegerArr    = Array[1..MaxIntervals] OF IntegerVect;
    Coordinate = Array[1..2] OF Integer;
    RealCoord  = Array[1..2] OF Single;
    BarArr     = Array[1..9] OF Coordinate;
VAR
   MaxHt,
   BaseY,GlobScaleX,
   GlobScaleY           : Integer;
   SinAng,CosAng        : Single;
   Spp                  : StringVect;
   AxesArr,WallArr      : Array[1..7] OF Coordinate;
   AxesZ                : Array[1..6] OF Integer;
   B                    : BarArr;
   Z                    : Array[1..9] OF Integer;
   Ch                   : Char;

{get the Sin, Cos once and store them in a global variable}

PROCEDURE Displacement(Angle : Single);
          BEGIN
               Angle  := DegToRad * Angle;    {from math}
               SinAng := Sin(Angle) * AspRatio;
               CosAng := Cos(Angle);
END;

{Perform a simple integer 3D rotation}

PROCEDURE Rotate(VAR Coord : Coordinate;Z : Integer);
          BEGIN
               Coord[1] := Round(Coord[1] +
                                 CosAng * Z -
                                 CosAng * Coord[1]);
               Coord[2] := Round(Coord[2] -
                                 SinAng * Z +
                                 SinAng * Coord[1]);
END;

{Perform a simple real 3D rotation and return an integer coordinate -
 used to create mesh}

PROCEDURE RealRotate(VAR Coord  : Coordinate;
                     VAR RCoord : RealCoord;
                         Z      : Single);
          BEGIN
               RCoord[1] :=  RCoord[1] + (CosAng * Z) -
                            (CosAng * RCoord[1]);
               Coord[2] :=  Round(RCoord[2] -
                                 (SinAng * Z) +
                                 (SinAng * RCoord[1]));
              Coord[1] := Round(RCoord[1]);
END;

{Create the polygons that are used to create the axes and the back wall}

PROCEDURE GetAxesArr;
          CONST
              X = 1; Y = 2; Z = 3;
         VAR
            Ct            : Byte;
            ScaleX,ScaleY : Integer;
          BEGIN
              ScaleX := GlobScaleX;
              ScaleY := BaseY;
              AxesArr[1,X] := 10;
              AxesArr[1,Y] := ScaleY;
              AxesZ[1] := 0;
              AxesArr[2,X] := ScaleX;
              AxesArr[2,Y] := ScaleY;
              AxesZ[2] := 0;
              AxesArr[3,X] := ScaleX;
              AxesArr[3,Y] := ScaleY;
              AxesZ[3] := MaxY;
              AxesArr[4,X] := 10;
              AxesArr[4,Y] := ScaleY;
              AxesZ[4] := MaxY;
              AxesArr[5,X] := ScaleX;
              AxesArr[5,Y] := AxesArr[3,2] - MaxHt;
              AxesZ[5] := MaxY;
              WallArr := AxesArr;
              FOR Ct := 1 TO 5 DO
                  Rotate(AxesArr[Ct],AxesZ[Ct]);
              WallArr[2]   := WallArr[4];
              WallArr[5,1] := WallArr[4,1];
              WallArr[5,2] := WallArr[4,2] - MaxHt;
              WallArr[4,1] := WallArr[3,1];
              WallArr[4,2] := WallArr[3,2] - MaxHt;
              WallArr[6,1] := WallArr[1,1];
              WallArr[6,2] := WallArr[1,2] - MaxHt;
              AxesZ[2] := AxesZ[4];
              AxesZ[5] := AxesZ[4];
              AxesZ[4] := AxesZ[3];
              AxesZ[6] := 0;
              FOR Ct := 1 TO 6 DO
                  Rotate(WallArr[Ct],AxesZ[Ct]);
END;

{Draw the axea and the back wall on the screen}

PROCEDURE DrawAxes(Max : Single);
          VAR
             St : String[7];
          BEGIN
              IF Gd <> 7 THEN
                 SetFillStyle(11,1)
              ELSE
                  SetFillStyle(1,0);
              Setcolor(Yellow);
              SetLineStyle(0,0,1);
              FillPoly(6,WallArr);
              Setcolor(White);
              SetLineStyle(0,0,3);
              SetFillStyle(9,1);
              FillPoly(4,AxesArr);
              Line(WallArr[2,1],WallArr[2,2],WallArr[5,1],WallArr[5,2]);
              Str(Max:7:2,St);
              SetTextJustify(2,0);
              SetfillStyle(1,0);
              Bar(WallArr[5,1]-60,WallArr[5,2] - 8,WallArr[5,1],WallArr[5,2]);
              OutTextXY(WallArr[5,1],WallArr[5,2],St);
END;

{Draw a single bar on the screen}

PROCEDURE MakeBar(XPos,Zpos,Ht,
                  ScaleX,ScaleY       : Integer;
                  Color               : Byte);
          VAR
             Ct        : Byte;
             X2,Y2,Z2  : Integer;
          BEGIN
               IF Ht = 0 THEN Exit;
               X2   := XPos + ScaleX;
               Y2   := BaseY - Ht;
               Z2   := ZPos + ScaleY;
               FillWord(Z,SizeOf(Z),ZPos);   {from utility}
               B[1,1] := XPos;
               B[1,2] := BaseY;
               B[2,1] := X2;
               B[2,2] := BaseY;
               B[2,1] := X2;
               B[2,2] := BaseY;
               B[3,1] := X2;
               B[3,2] := Y2;
               B[4,1] := XPos;
               B[4,2] := Y2;
               B[5]   := B[4];
               B[5,2] := Y2;
               Z[5]   := Z2;
               B[6]   := B[3];
               Z[6]   := Z2;
               B[7]   := B[2];
               Z[7]   := Z2;
               B[8]   := B[2];
               B[9]   := B[3];
               FOR Ct := 1 TO 9 DO
                   Rotate(B[Ct],Z[Ct]);
               SetFillStyle(7,Color);
               FillPoly(4,B[6]);
               SetFillStyle(11,Color);
               FillPoly(4,B[3]);
               SetFillStyle(1,Color);
               FillPoly(4,B);
END;

{Draw the entire matrix of bars}

PROCEDURE DrawBars(     Row,Col     : Byte;
                    VAR SpeciesDist : IntegerArr;
                        Color       : Byte);
          VAR
             Ct,BarBaseX,BarBaseZ,
             BarScaleX,BarScaleZ,
             XStart,ZStart                     : Integer;
             Ct1,Ct2                           : Byte;
             FillColor                         : Byte;
          BEGIN
               BarScaleX := GlobScaleX DIV Col;
               BarScaleZ := MaxY DIV Row;
               BarBaseX := BarScaleX SHR 1;
               BarBaseZ := BarScaleZ SHR 1;
               IF BarBaseZ > 50 THEN
                  BarBaseZ := 50;
               SetColor(LightCyan);
               SetLineStyle(0,0,0);
               ZStart := MaxY - BarScaleZ;
               FOR Ct1 := 1 TO Row DO BEGIN
                   XStart := 30;
                   FOR Ct2 := 1 TO Col DO BEGIN
                       IF Color <> 0 THEN
                          Fillcolor := Color
                       ELSE
                           Fillcolor := Ct1 MOD 14 + 1;
                       MakeBar(XStart,ZStart,SpeciesDist[Ct1,Ct2],
                               BarBaseX,BarBaseZ,FillColor);
                       Inc(XStart,BarScaleX);
                   END;
                       Dec(ZStart,BarScaleZ);
               END;
END;

{Draw the mesh}

PROCEDURE DrawMesh(     Row,Col     : Byte;
                    VAR SpeciesDist : IntegerArr;
                        Color       : Byte);
          VAR
             Ct                                : Word;
             XPlus1,ZPlus1,
             XStart,ZStart,
             BarScaleX,BarScaleZ               : Single;
             Ct1,Ct2                           : Byte;
             RCoord                            : RealCoord;
             Square                            : Array[1..4] OF Coordinate;
          BEGIN
               BarScaleX := (GlobScaleX-10)/Pred(Col);
               BarScaleZ := (MaxY-2)/Pred(Row);
               SetColor(LightCyan);
               SetLineStyle(0,0,0);
               ZStart := MaxY;
               FOR Ct1 := 1 TO Pred(Row) DO BEGIN
                   ZPlus1 := ZStart - BarScaleZ;
                   XStart := 10;
                   FOR Ct2 := 1 TO Pred(Col) DO BEGIN
                       XPlus1 := XStart + BarScaleX;
                       RCoord[1] := XStart;
                       RCoord[2] := BaseY - SpeciesDist[Ct1,Ct2];
                       RealRotate(Square[1],RCoord,ZStart);
                       RCoord[1] := XPlus1;
                       RCoord[2] := BaseY - SpeciesDist[Ct1,Succ(Ct2)];
                       RealRotate(Square[2],RCoord,ZStart);
                       RCoord[1] := XPlus1;
                       RCoord[2] := BaseY - SpeciesDist[Succ(Ct1),Succ(Ct2)];
                       RealRotate(Square[3],RCoord,ZPlus1);
                       RCoord[1] := XStart;
                       RCoord[2] := BaseY - SpeciesDist[Succ(Ct1),Ct2];
                       RealRotate(Square[4],RCoord,ZPlus1);
                       IF Gd <> 7 THEN
                          SetFillStyle(1,Color)
                       ELSE
                           SetFillStyle(10,Color);
                       FillPoly(4,Square);
                       XStart := XPlus1;
                   END;
                       ZStart := ZPlus1;
               END;
END;
{Draw the entire matrix of areas}

PROCEDURE DrawAreas(     Row,Col     : Byte;
                     VAR SpeciesDist : IntegerArr);
          VAR
             Ct,AreaScaleX,AreaScaleZ,
             XStart,ZStart                     : Integer;
             Ct1,Ct2                           : Byte;
             CoordArr                          : Array[1..MaxIntervals + 2] OF
                                                 Coordinate;
          BEGIN
               AreaScaleX := GlobScaleX DIV Col;
               AreaScaleZ := MaxY DIV Row;
               SetColor(LightCyan);
               SetLineStyle(0,0,0);
               ZStart := MaxY - AreaScaleZ;
               FOR Ct1 := 1 TO Row DO BEGIN
                   XStart := 30;
                   CoordArr[1,1] := XStart;
                   CoordArr[1,2] := BaseY;
                   Rotate(CoordArr[1],ZStart);
                   FOR Ct2 := 2 TO Succ(Col) DO BEGIN
                       CoordArr[Ct2,1] := XStart;
                       CoordArr[Ct2,2] := BaseY - SpeciesDist[Ct1,Pred(Ct2)];
                       Rotate(CoordArr[Ct2],ZStart);
                       Inc(XStart,AreaScaleX);
                   END;
                   Inc(Ct2);
                   Dec(XStart,AreaScaleX);
                   CoordArr[Ct2,1] := XStart;
                   CoordArr[Ct2,2] := BaseY;
                   Rotate(CoordArr[Ct2],ZStart);
                   IF Gd <> 7 THEN
                      SetFillStyle(1,Ct1 MOD 14 + 1)
                   ELSE
                       SetFillStyle(Ct1 MOD 9 + 2,1);
                   FillPoly(Ct2,CoordArr);
                   Dec(ZStart,AreaScaleZ);
               END;
END;

{Draw the axes titles and labels}

PROCEDURE DrawLegends(    Row,Col      : Byte;
                      VAR Species      : StringVect;
                          DStart,DInc  : Single;
                      VAR Title,Msg    : String);
          VAR
             Ct,BarBaseX,BarBaseZ,
             BarScaleX,BarScaleZ,
             XStart,ZStart,Z            : Integer;
             C                          : Coordinate;
             St                         : String[5];
          BEGIN
               SetColor(White);
               OutTextXY(0,MaxY - 80,'DIAMETER (in.)');
               OutTextXY(MaxX - 150,MaxY - 50,'SPECIES');
               WriteTitle(MaxX - 100,30,Title,Msg);
               BarScaleX := GlobScaleX DIV Col;
               BarScaleZ := MaxY DIV Row;
               XStart := 20 + BarScaleX;
               FOR Ct := 1 TO Col DO BEGIN   {do the diameters}
                   C[1] := XStart;
                   C[2] := BaseY;
                   Rotate(C,-20);
                   Str(DStart:1:0,St);
                   OutTextXY(C[1],C[2],St);
                   Inc(XStart,BarScaleX);
                   DStart := DStart + DInc;
               END;
               ZStart :=  MaxY - BarScaleZ;
               XStart :=  GlobScaleX + 50;
               SetTextJustify(0,0);
               FOR Ct := 1 TO Row DO BEGIN   {do the diameters}
                   C[1] := XStart;
                   C[2] := BaseY;
                   Rotate(C,ZStart);
                   OutTextXY(C[1],C[2],Species[Ct]);
                   Dec(ZStart,BarScaleZ);
               END;
               SetTextJustify(0,2);
END;

{draws the titles and labels for the axes on the generic bar chart}

PROCEDURE DrawLegendsG(    Row,Col                    : Byte;
                           AStart,AInc,BStart,BInc    : Single;
                       VAR Title,XTitle,YTitle,Msg    : String;
                           AxisLabels                 : Boolean);
          VAR
             Ct,BarBaseX,BarBaseZ,
             BarScaleX,BarScaleZ,
             XStart,ZStart,Z            : Integer;
             C                          : Coordinate;
             St                         : String[5];
          BEGIN
               SetColor(White);
               OutTextXY(0,MaxY - 100,XTitle);
               OutTextXY(MaxX - 150,MaxY - 50,YTitle);
               WriteTitle(MaxX - 100,30,Title,Msg);
               IF AxisLabels THEN BEGIN
                  BarScaleX := GlobScaleX DIV Col;
                  BarScaleZ := MaxY DIV Row;
                  XStart := 20 + BarScaleX;
                  FOR Ct := 1 TO Col DO BEGIN   {do the diameters}
                      IF Ct = Col THEN BEGIN
                         C[1] := XStart;
                         C[2] := BaseY;
                         Rotate(C,-20);
                         Str(AStart:1:0,St);
                         OutTextXY(C[1],C[2],St);
                      END;
                      Inc(XStart,BarScaleX);
                      AStart := AStart + AInc;
                  END;
                  ZStart :=  MaxY - BarScaleZ - 10;
                  XStart :=  GlobScaleX + 50;
                  SetTextJustify(0,0);
               END;
               SetTextJustify(0,2);
END;

{Draw the legends for the mesh}

PROCEDURE DrawLegendsM(    Row,Col                    : Byte;
                           AStart,AInc,BStart,BInc    : Single;
                       VAR Title1,Title2,XTitle,
                           YTitle,Msg                 : String;
                           AxisLabels                 : Boolean);
          VAR
             Ct,BarBaseX,BarBaseZ,
             BarScaleX,BarScaleZ,
             XStart,ZStart,Z,Skip       : Integer;
             C                          : Coordinate;
             St                         : String[5];
          BEGIN
               SetColor(White);
               OutTextXY(0,MaxY - 100,XTitle);
               OutTextXY(MaxX - 150,MaxY - 50,YTitle);
               WriteTitle(MaxX - 100,30,Title1,Msg);
               SetTextJustify(0,1);
               OutTextXY(MaxX - 100,45,Title2);
               SetTextJustify(2,0);
               IF AxisLabels THEN BEGIN
                  BarScaleX := Round((GlobScaleX - 10)/Pred(Col));
                  BarScaleZ := Round(MaxY/Pred(Row));
                  XStart := 10 + BarScaleX + 30;
                  Skip := Col DIV 10;
                  AStart := AStart + AInc;
                  IF Skip = 0 THEN
                     Skip := 1;
                  FOR Ct := 2 TO Col DO BEGIN   {do the diameters}
                      IF Ct MOD Skip = 0 THEN BEGIN
                         C[1] := XStart;
                         C[2] := BaseY;
                         Rotate(C,-25);
                         Str(AStart:1:0,St);
                         OutTextXY(C[1],C[2],St);
                      END;
                      Inc(XStart,BarScaleX);
                      AStart := AStart + AInc;
                  END;
                  ZStart :=  MaxY - BarScaleZ - 10;
                  XStart :=  GlobScaleX + 50;
                  Skip := Row DIV 10;
                  IF Skip = 0 THEN
                     Skip := 1;
                  BStart := BStart + BInc;
                  SetTextJustify(0,0);
                  FOR Ct := 2 TO Row DO BEGIN   {do the diameters}
                      IF Ct MOD Skip = 0 THEN BEGIN
                         C[1] := XStart;
                         C[2] := BaseY;
                         Rotate(C,ZStart);
                         Str(BStart:1:0,St);
                         OutTextXY(C[1],C[2],St);
                      END;
                      Dec(ZStart,BarScaleZ);
                      BStart := BStart + BInc;
                  END;
               END;
               SetTextJustify(0,2);
END;
{Scale the matrix to the screen and return as an integer matrix}

PROCEDURE ScaleMatrix(    Row,Col  : Byte;
                      VAR M        : Matrix;
                      VAR Maximum  : Single;
                      VAR GraphArr : IntegerArr);
          VAR
             Ct             : Byte;
             Holder         : Single;
          BEGIN
               Maximum := 0;
               FOR Ct := 1 TO Row DO BEGIN
                   Holder := Max(Col,M[Ct]);           {whole matrix}
                   IF Holder > Maximum THEN
                      Maximum := Holder;
               END;
               IF Maximum <> 0 THEN
                  Holder := MaxHt/Maximum;           {scale to screen}
               FOR Ct := 1 TO Row DO               {scale the whole matrix}
                   RoundAndScaleRow(Col,Holder,M[Ct],GraphArr[Ct]);
END;

{makes a 3d bar chart of a positive matrix - entries must be positive- you
 need a good deal of stack for this one Row * Col * 2}

PROCEDURE Graph3DBars(    Row,Col         : Byte;
                      VAR M               : Matrix;
                      VAR Species         : StringVect;
                          DiamStart,
                          DiamInc         : Single;
                          Title,Message   : String;
                          FirstTime       : Boolean);
          VAR
             GraphArr       : IntegerArr;
             Maximum        : Single;
         BEGIN
               ScaleMatrix(Row,Col,M,Maximum,GraphArr);
               IF FirstTime THEN BEGIN
                  Displacement(45);
                  GetAxesArr;
                  DrawLegends(Row,Col,Species,DiamStart,DiamInc,Title,
                              Message);
               END;
               DrawAxes(Maximum);
               DrawBars(Row,Col,GraphArr,0);
END;

{a generic 3D bars routine that has numeric values on each axis}

PROCEDURE Graph3DBarsG(    Row,Col         : Byte;
                       VAR M               : Matrix;
                           XStart,
                           XInc,
                           YStart,
                           YInc            : Single;
                           Title,XTitle,
                           YTitle,Message  : String;
                           Color           : Byte;
                           FirstTime       : Boolean);
          VAR
             GraphArr       : IntegerArr;
             Maximum        : Single;
          BEGIN
               ScaleMatrix(Row,Col,M,Maximum,GraphArr);
               IF FirstTime THEN BEGIN
                  Displacement(45);
                  GetAxesArr;
                  DrawLegendsG(Row,Col,XStart,XInc,YStart,YInc,Title,
                               XTitle,YTitle,Message,TRUE);
               END;
               DrawAxes(Maximum);
               DrawBars(Row,Col,GraphArr,Color);
END;
{makes a 3D chart using areas rather than bars - faster than bars}

PROCEDURE Graph3DAreas(    Row,Col         : Byte;
                       VAR M               : Matrix;
                       VAR Species         : StringVect;
                           DiamStart,
                           DiamInc         : Single;
                           Title,Message   : String;
                           FirstTime       : Boolean);
          VAR
             GraphArr       : IntegerArr;
             Maximum        : Single;
          BEGIN
               ScaleMatrix(Row,Col,M,Maximum,GraphArr);
               IF FirstTime THEN BEGIN
                  Displacement(45);
                  GetAxesArr;
                  DrawLegends(Row,Col,Species,DiamStart,DiamInc,Title,
                              Message);
               END;
               DrawAxes(Maximum);
               DrawAreas(Row,Col,GraphArr);
END;
PROCEDURE Graph3DMesh (    Row,Col         : Byte;
                       VAR M               : Matrix;
                           XStart,
                           XInc,
                           YStart,
                           YInc            : Single;
                           Title1,Title2,
                           XTitle,
                           YTitle,Message  : String;
                           Color           : Byte;
                           FirstTime       : Boolean);
          VAR
             GraphArr       : IntegerArr;
             Maximum        : Single;
          BEGIN
               ScaleMatrix(Row,Col,M,Maximum,GraphArr);
               IF FirstTime THEN BEGIN
                  Displacement(45);
                  GetAxesArr;
                  DrawLegendsM(Row,Col,XStart,XInc,YStart,YInc,Title1,Title2,
                               XTitle,YTitle,Message,TRUE);
               END;
               DrawAxes(Maximum);
               DrawMesh(Row,Col,GraphArr,Color);
END;
{initializes graphics and global constants}

PROCEDURE Init3DGraphics;
          BEGIN
               InitializeGraphics;
               MaxHt := MaxY SHR 2;
               CASE Gd OF
                   9 : BEGIN
                              BaseY := MaxY - 250;
                              GlobScaleX := MaxX + MaxX SHR 1;
                          END;
                    7 : BEGIN
                              BaseY := MaxY - 200;
                              GlobScaleX := MaxX + MaxX SHR 1;
                          END;
                    3   : BEGIN
                               BaseY := MaxY - 200;
                               GlobScaleX := MaxX + 50;
                          END;
               END;
END;
BEGIN
END.

