UNIT LaserPr;

INTERFACE

USES Printer,Graph,Crt;

PROCEDURE LaserPrintScreen(Device : Word;VAR Err : Boolean);
PROCEDURE LaserLandscapePrintScreen(Device : Word;VAR Err : Boolean);

IMPLEMENTATION

TYPE
    CharArr = Array[1..100] OF Char;
PROCEDURE WriteLine(CharNo : Word;x : CharArr;VAR Err : Boolean);
          VAR
             Ct : Word;
          BEGIN
               Write(Lst,#27'*b',CharNo,'W');
               FOR Ct := 1 TO CharNo DO
                   Write(Lst,x[Ct]);
               Err := IOResult <> 0;
END;
PROCEDURE SetPrintGraphics(Device : Word;VAR Error : Boolean);
          BEGIN
               Write(Lst,#27'*t100R'#27'*r0A');
               Error := IOResult <> 0;

END;
PROCEDURE KillPrintGraphics(VAR Error : Boolean);
          BEGIN
               Write(Lst,#27'*rB');
               Write(Lst,#12);
               Error := IOResult <> 0;
END;
PROCEDURE LaserPrintScreen(Device : Word;VAR Err : Boolean);
          VAR
             Rows,Columns     : Word;
             Ct1,Ct2,Element,
             LineWidth        : Word;
             BitCtr,OutBit    : Byte;
             Pixel            : Word;
             Arr              : CharArr;
             Ch               : Char;
          BEGIN
               FillChar(Arr,SizeOf(Arr),0);
               SetPrintGraphics(Device,Err);
               IF Err THEN Exit;
               Rows := GetMaxY;
               Columns := GetMaxX;
               LineWidth := Succ(Columns SHR 3); {div 8}
               FOR Ct1 := 0 TO Rows DO BEGIN
                   BitCtr := 8;
                   Element := 0;
                   Outbit := 0;
                   FOR Ct2 := 0 TO Columns DO BEGIN
                       Dec(BitCtr);
                       IF BitCtr > 7 THEN BEGIN
                          BitCtr := 7;
                          Inc(Element);
                          Arr[Element] := Char(OutBit);
                          Outbit := 0;
                       END;
                       Pixel := GetPixel(Ct2,Ct1);
                       IF Pixel <> 0 THEN BEGIN
                          OutBit := OutBit OR (1 SHL BitCtr);
                       END;
                   END;
                   Arr[Element] := Char(OutBit);
                   WriteLine(LineWidth,Arr,Err);
                   IF Err THEN Exit;
                   IF Keypressed THEN BEGIN
                      Ch := ReadKey;
                      IF Ch = #27 THEN BEGIN
                         KillPrintGraphics(Err);
                         Exit;
                      END
                      ELSE IF Ch = #0 THEN
                           Ch := ReadKey;
                   END;
               END;
               KillPrintGraphics(Err);
END;
PROCEDURE LandscapeSetPrintGraphics(Device : Word;VAR Error : Boolean);
          BEGIN
               Write(Lst,#27'*t150R'#27'*r0A');
               Error := IOResult <> 0;
END;
PROCEDURE DoubleBits(x : Byte;VAR y : Word);
          VAR
             Ct,Ctr,Sh : Byte;
          BEGIN
               Ctr := 0;
               y   := 0;
               FOR Ct := 0 TO 7 DO BEGIN
                   Sh := 1 SHL Ct;
                   IF x AND Sh <> 0 THEN BEGIN
                      y := y OR (1 SHL Ctr);
                      y := y OR (1 SHL Succ(Ctr));
                   END;
                   Inc(Ctr,2);
               END;
END;
PROCEDURE LandscapeWriteLine(CharNo : Word;x : CharArr;VAR Err : Boolean);
          VAR
             Ct,Ct2 : Word;
             Db : Word;
          BEGIN
               FOR Ct2 := 1 TO 2 DO BEGIN
                  Write(Lst,#27'*b',CharNo*2,'W');
                  FOR Ct := 1 TO CharNo DO BEGIN
                      DoubleBits(Byte(x[Ct]),Db);
                      Write(Lst,Char(Hi(Db)),Char(Lo(Db)));
                   END;
               END;
               Err := IOResult <> 0
END;
PROCEDURE LaserLandscapePrintScreen(Device : Word;VAR Err : Boolean);
          VAR
             Rows,Columns     : Word;
             Ct1,Ct2,Element,
             LineWidth        : Word;
             BitCtr,OutBit    : Byte;
             Pixel            : Word;
             Arr              : CharArr;
             Ch               : Char;
          BEGIN
               FillChar(Arr,SizeOf(Arr),0);
               LandscapeSetPrintGraphics(Device,Err);
               IF Err THEN Exit;
               Rows := GetMaxY;
               Columns := GetMaxX;
               LineWidth := Succ(Rows SHR 3); {div 8}
               FOR Ct1 := Columns DOWNTO 0 DO BEGIN
                   BitCtr := 8;
                   Element := 0;
                   Outbit := 0;
                   FOR Ct2 := 0 TO Rows DO BEGIN
                       Dec(BitCtr);
                       IF BitCtr > 7 THEN BEGIN
                          BitCtr := 7;
                          Inc(Element);
                          Arr[Element] := Char(OutBit);
                          Outbit := 0;
                       END;
                       Pixel := GetPixel(Ct1,Ct2);
                       IF Pixel <> 0 THEN BEGIN
                          OutBit := OutBit OR (1 SHL BitCtr);
                       END;
                   END;
                   Inc(Element);
                   Arr[Element] := Char(OutBit);
                   LandscapeWriteLine(LineWidth,Arr,Err);
                   IF Err THEN Exit;
                   IF Keypressed THEN BEGIN
                      Ch := ReadKey;
                      IF Ch = #27 THEN BEGIN
                         KillPrintGraphics(Err);
                         Exit;
                      END
                      ELSE IF Ch = #0 THEN
                           Ch := ReadKey;
                   END;
               END;
               KillPrintGraphics(Err);
END;
BEGIN
END.