UNIT VGAPal;

INTERFACE

USES Graph;

CONST
     MaxChoice = 1;
     Default   = 2;
     Gradient  = 3;
     BlueToRed = 4;
     GrayScale = 5;
     Normal    = 6;
     PaletteNo : Byte = 2; {start with gradient}

PROCEDURE ChangePalette(NewColors : Byte);
PROCEDURE NewPalette;

IMPLEMENTATION

TYPE

RGBRec     = Array[1..3] OF Byte;
RGBPalette = Array[1..15] OF RGBRec;

CONST

RedVal   = 1;
GreenVal = 2;
BlueVal  = 3;

Norm : RGBPalette =
((0,0,112),    {blue}
 (20,112,0),    {green}
 (0,112,112),  {cyan}
 (112,0,0),    {red}
 (112,0,112),  {magenta}
 (112,22,0),   {brown}
 (45,45,45),   {white}
 (20,20,20),   {grey}
 (0,0,252),    {lt. blue}
 (0,252,0),    {lt. green}
 (0,252,252),  {lt. cyan}
 (252,0,0),    {lt. red}
 (252,0,252),  {lt. magenta}
 (252,252,0),  {yellow}
 (252,252,252)); {white}

DefCol : RGBPalette =
((0,0,112),    {blue}
 (0,0,252),    {lt. blue}
 (0,112,112),  {cyan}
 (20,112,0),    {green}
 (0,252,0),    {lt. green}
 (252,252,0),  {yellow}
 (112,0,0),    {red}
 (252,0,0),    {lt. red}
 (252,0,252),  {lt. magenta}
 (112,0,112),  {magenta}
 (0,252,252),  {lt. cyan}
 (112,22,0),   {brown}
 (45,45,45),   {white}
 (20,20,20),   {grey}
 (252,252,252)); {white}

Grad : RGBPalette =
((25,12,252),
 (10,30,252),
 (30,112,112),
 (30,252,45),
 (40,120,30),
 (252,252,0),
 (252,180,210),
 (252,168,216),
 (252,156,210),
 (252,0,0),
 (0,252,252),    {lt. cyan}
 (45,45,45),     {lt. red}
 (252,0,252),    {lt. magenta}
 (252,252,0),    {yellow}
 (252,252,252)); {white}

GScale : RGBPalette =
(
 (24,24,24),
 (28,28,28),
 (32,32,32),
 (36,36,36),
 (40,40,40),
 (44,44,44),
 (48,48,48),
 (52,52,52),
 (56,56,56),
 (63,63,63),
 (0,252,252),    {lt. cyan}
 (45,45,45),     {lt. red}
 (252,0,252),    {lt. magenta}
 (252,252,0),    {yellow}
 (252,252,252)); {white}

MxChoice : RGBPalette =
(
(44,22,252),    {lt. purple}
(142,35,10),    {army green}
(252,30,34),    {peach}
(252,112,30),   {brown}
(252,86,0),     {orange}
(252,60,112),   {egg shell}
 (232,242,252), {sky blue}
 (112,22,0),    {brown}
 (0,0,252),     {lt. blue}
 (0,252,0),     {lt. green}
 (0,252,252),   {lt. cyan}
 (252,0,0),     {lt. red}
 (252,0,252),   {lt. magenta}
 (252,252,0),   {yellow}
 (252,252,252));{white}

 BToR : RGBPalette =
(
 (0,0,63),
 (7,0,56),
 (14,0,49),
 (21,0,42),
 (28,0,35),
 (35,0,28),
 (42,0,21),
 (49,0,14),
 (56,0,7),
 (63,0,0),
 (0,252,252),    {lt. cyan}
 (45,45,45),     {lt. red}
 (252,0,252),    {lt. magenta}
 (252,252,0),    {yellow}
 (252,252,252)); {white}

Palette : Array[1..17] OF Byte = (16,0,1,2,3,4,5,6,7,8,9,10,11,
                                  12,13,14,15);


PROCEDURE ChangePalette(NewColors : Byte);
          VAR
             Ct        : Byte;
             ColorPal : RGBPalette;
          BEGIN
               CASE NewColors OF
                    MaxChoice : ColorPal := MxChoice;
                    Default   : ColorPal := DefCol;
                    Gradient  : ColorPal := Grad;
                    BlueToRed : ColorPal := BToR;
                    GrayScale : ColorPal := GScale;
                    Normal    : ColorPal := Norm;
               END;
               FOR Ct := 1 TO 15 DO BEGIN
                        SetRGBPalette(Ct,ColorPal[Ct,RedVal],
                                         ColorPal[Ct,GreenVal],
                                         ColorPal[Ct,BlueVal]);
               END;
               SetAllPalette(Palette);
END;
PROCEDURE NewPalette;
          BEGIN
               Inc(PaletteNo);
               IF PaletteNo = 6 THEN
                  PaletteNo := 2;
               ChangePalette(PaletteNo);
END;



BEGIN
END.
